package pl.net.linux.krzak.kchat.applet;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;

public class kChatActions implements ActionListener, ItemListener, WindowListener {
    private Dialog    passDialog = null;
    private TextField passInput  = null;
    private TextField guestInput = null;
    private Dialog    topicDialog = null;
    private TextField topicInput  = null;
    private kChatApplet applet = null;

    public kChatActions(kChatApplet a) { applet = a; }

    public void actionPerformed(ActionEvent e) {
	if (applet==null) return;
	/* LOGOUT */
	if (e.getActionCommand().equals("LOGOUT")) {
	    applet.closeAllFloatingWindow();
	    applet.chanWnd.appendText(applet.TXT[1],applet.alertColor); // "Zostales wylogowany"
	    if (applet.net != null) {
		applet.net.send("*CLOSE");
	        applet.net.disconnect();
		}
	    applet.net=null;
	    applet.actions=null;
	    applet.context.showDocument(applet.logouthtml,"_self");
	    return;
	}
	/* PRIVATE */
	if (e.getActionCommand().equals("PRIVATE")) {
	 if ((!(applet.login.equals(applet.selectedNick))) &&
	    (!(applet.selectedNick.equals(""))) &&
	    (applet.alreadyExistNick(applet.selectedNick) == false)) {
	    MsgFloatingWindow fw = new MsgFloatingWindow(applet.compileText(applet.TXT[12],applet.selectedNick),applet.selectedNick,applet);
	    fw.setVisible(true);
	   }
	 return;
	 }
	 
	/* MODERATOR */
	if (e.getActionCommand().equals("MODERATOR") && (applet.net != null)) {
	passDialog = new Dialog(new Frame(),applet.TXT[13],true);
	passInput = new TextField("password",20);
	guestInput = new TextField("guest",20);

	Button passOK = new Button("OK");
	passOK.setActionCommand("PASSOK");
	passOK.addActionListener(this);

	passDialog.add(passInput,BorderLayout.NORTH);
	passDialog.add(guestInput,BorderLayout.CENTER);
	passDialog.add(passOK,BorderLayout.SOUTH);
	passDialog.addWindowListener(this);
	passDialog.setResizable(true);
	passDialog.setSize(200,110);
	passDialog.show();
	return;
	}

	/* TOPIC */
	if (e.getActionCommand().equals("TOPIC")) {
	topicDialog = new Dialog(new Frame(),applet.TXT[17],true);
	topicInput = new TextField("",30);

	Button topicOK = new Button("OK");
	topicOK.setActionCommand("TOPICOK");
	topicOK.addActionListener(this);

	topicDialog.add(topicInput,BorderLayout.NORTH);
	topicDialog.add(topicOK,BorderLayout.CENTER);
	topicDialog.addWindowListener(this);
	topicDialog.setResizable(true);
	topicDialog.setSize(200,80);
	topicDialog.show();
	return;
	}

	/* PASSOK */
	if (e.getActionCommand().equals("PASSOK")) {
	 if ( (passInput != null) && (guestInput != null) &&
	   (!passInput.getText().equals("")) && (!guestInput.getText().equals("")) ) {
	   applet.net.send("*MODERATOR|" + passInput.getText() + "|" + guestInput.getText() + "|");
	   passDialog.dispose();
	   }
	return;
	}

	/* TOPICOK */
	if (e.getActionCommand().equals("TOPICOK")) {
	 if ( (topicInput != null) && (topicInput != null) &&
	   (!topicInput.getText().equals("")) ) {
	   applet.net.send("*TOPIC|SET|" +applet.chan + "|" + topicInput.getText() + "|");
	   topicDialog.dispose();
	   }
	return;
	}

	// KICKBUTTON
	if ((e.getActionCommand().equals("KICK")) &&
	   (!applet.login.equals(applet.selectedNick)) &&
	   (!applet.selectedNick.equals(""))) {
	    applet.closeAllFloatingWindow();
	    applet.net.send("*KICK|"+applet.selectedNick+"|");
	    return;
	    }

    }

    public void itemStateChanged(ItemEvent e) {
	if (e.getStateChange() == ItemEvent.SELECTED)
	    { applet.selectedNick = applet.nList.getSelectedItem(); }
    }

    public void windowClosing(WindowEvent e) {  e.getWindow().dispose(); }
    public void windowClosed(WindowEvent e) {  }
    public void windowOpened(WindowEvent e) {  }
    public void windowIconified(WindowEvent e) { }
    public void windowDeiconified(WindowEvent e) { }
    public void windowActivated(WindowEvent e) { }
    public void windowDeactivated(WindowEvent e) { }

}